### Hierarchy

- default

### Implements

- Puttable

## Index

### Constructors

- constructor

### Properties

- links
- mmpt
- prettyTree
- privateLog
- privateNodes
- publicTree
- sharedCounter
- sharedLinks
- LOG_CHUNK_SIZE

### Methods

- addPrivateLogEntry
- addShares
- bumpSharedCounter
- findPrivateNode
- getVersion
- put
- putDetailed
- setSharedCounter
- setVersion
- updateLink
- updatePuttable
- empty
- fromCID
- getSharedLinks
- retrieveRootKey
- storeRootKey

## Constructors

### constructor

- new default(__namedParameters: { links: SimpleLinks; mmpt: <internal>.default; prettyTree: BareTree; privateLog: SimpleLink[]; privateNodes: Record<string, PrivateNode>; publicTree: UnixTree & Puttable; sharedCounter: number; sharedLinks: SimpleLinks }): <internal>.default

- - Defined in fs/root/tree.ts:49

  #### Parameters

  - ##### __namedParameters: { links: SimpleLinks; mmpt: <internal>.default; prettyTree: BareTree; privateLog: SimpleLink[]; privateNodes: Record<string, PrivateNode>; publicTree: UnixTree & Puttable; sharedCounter: number; sharedLinks: SimpleLinks }

    - ##### links: SimpleLinks

    - ##### mmpt: <internal>.default

    - ##### prettyTree: BareTree

    - ##### privateLog: SimpleLink[]

    - ##### privateNodes: Record<string, PrivateNode>

    - ##### publicTree: UnixTree & Puttable

    - ##### sharedCounter: number

    - ##### sharedLinks: SimpleLinks

  #### Returns <internal>.default

## Properties

### links

links: SimpleLinks

- Defined in fs/root/tree.ts:38

### mmpt

mmpt: <internal>.default

- Defined in fs/root/tree.ts:39

### prettyTree

prettyTree: BareTree

- Defined in fs/root/tree.ts:46

### privateLog

privateLog: SimpleLink[]

- Defined in fs/root/tree.ts:40

### privateNodes

privateNodes: Record<string, PrivateNode>

- Defined in fs/root/tree.ts:47

### publicTree

publicTree: UnixTree & Puttable

- Defined in fs/root/tree.ts:45

### sharedCounter

sharedCounter: number

- Defined in fs/root/tree.ts:42

### sharedLinks

sharedLinks: SimpleLinks

- Defined in fs/root/tree.ts:43

### Static LOG_CHUNK_SIZE

LOG_CHUNK_SIZE: number = 1020

- Defined in fs/root/tree.ts:259

## Methods

### addPrivateLogEntry

- addPrivateLogEntry(cid: CID): Promise<void>

- - Defined in fs/root/tree.ts:262

  #### Parameters

  - ##### cid: CID

  #### Returns Promise<void>

### addShares

- addShares(links: SimpleLink[]): Promise<<internal>.default>

- - Defined in fs/root/tree.ts:309

  #### Parameters

  - ##### links: SimpleLink[]

  #### Returns Promise<<internal>.default>

### bumpSharedCounter

- bumpSharedCounter(): Promise<number>

- - Defined in fs/root/tree.ts:376

  #### Returns Promise<number>

### findPrivateNode

- findPrivateNode(path: DistinctivePath): [DistinctivePath, null | PrivateNode]

- - Defined in fs/root/tree.ts:247

  #### Parameters

  - ##### path: DistinctivePath

  #### Returns [DistinctivePath, null | PrivateNode]

### getVersion

- getVersion(): Promise<null | SemVer>

- - Defined in fs/root/tree.ts:390

  #### Returns Promise<null | SemVer>

### put

- put(): Promise<CID>

- Implementation of Puttable.put

  - Defined in fs/root/tree.ts:212

  #### Returns Promise<CID>

### putDetailed

- putDetailed(): Promise<AddResult>

- Implementation of Puttable.putDetailed

  - Defined in fs/root/tree.ts:217

  #### Returns Promise<AddResult>

### setSharedCounter

- setSharedCounter(counter: number): Promise<number>

- - Defined in fs/root/tree.ts:360

  #### Parameters

  - ##### counter: number

  #### Returns Promise<number>

### setVersion

- setVersion(v: SemVer): Promise<<internal>.default>

- - Defined in fs/root/tree.ts:385

  #### Parameters

  - ##### v: SemVer

  #### Returns Promise<<internal>.default>

### updateLink

- updateLink(name: string, result: AddResult): <internal>.default

- - Defined in fs/root/tree.ts:221

  #### Parameters

  - ##### name: string

  - ##### result: AddResult

  #### Returns <internal>.default

### updatePuttable

- updatePuttable(name: string, puttable: Puttable): Promise<<internal>.default>

- - Defined in fs/root/tree.ts:227

  #### Parameters

  - ##### name: string

  - ##### puttable: Puttable

  #### Returns Promise<<internal>.default>

### Static empty

- empty(__namedParameters: { rootKey: string; wnfsWasm?: boolean }): Promise<<internal>.default>

- - Defined in fs/root/tree.ts:77

  #### Parameters

  - ##### __namedParameters: { rootKey: string; wnfsWasm?: boolean }

    - ##### rootKey: string

    - ##### Optional wnfsWasm?: boolean

  #### Returns Promise<<internal>.default>

### Static fromCID

- fromCID(__namedParameters: { cid: CID; permissions?: Permissions }): Promise<<internal>.default>

- - Defined in fs/root/tree.ts:126

  #### Parameters

  - ##### __namedParameters: { cid: CID; permissions?: Permissions }

    - ##### cid: CID

    - ##### Optional permissions?: Permissions

  #### Returns Promise<<internal>.default>

### Static getSharedLinks

- getSharedLinks(cid: CID): Promise<SimpleLinks>

- - Defined in fs/root/tree.ts:337

  #### Parameters

  - ##### cid: CID

  #### Returns Promise<SimpleLinks>

### Static retrieveRootKey

- retrieveRootKey(): Promise<string>

- - Defined in fs/root/tree.ts:241

  #### Returns Promise<string>

### Static storeRootKey

- storeRootKey(rootKey: string): Promise<void>

- - Defined in fs/root/tree.ts:235

  #### Parameters

  - ##### rootKey: string

  #### Returns Promise<void>

Generated using TypeDoc